Home | History | Annotate | Line # | Download | only in dist
makedefs revision 1.2
      1 #!/bin/sh
      2 
      3 #++
      4 # NAME
      5 #	makedefs 1
      6 # SUMMARY
      7 #	makefile configuration utility
      8 # SYNOPSIS
      9 #	\fBmake makefiles \fIname=value...\fR
     10 # DESCRIPTION
     11 #	The \fBmakedefs\fR command identifies the compilation
     12 #	environment, and emits macro definitions on the standard output
     13 #	stream that can be prepended to template Makefiles.
     14 #
     15 #	Default settings can be overruled by specifying them as
     16 #	environment variables. Use quotes if variables contain
     17 #	whitespace or shell meta characters.
     18 # .IP \fBAUXLIBS=\fIobject_library...\fR
     19 #	Specifies one or more non-default object libraries.
     20 # .IP \fBCC=\fIcompiler_command\fR
     21 #	Specifies a non-default compiler. On many systems, the default
     22 #	is \fBgcc\fR.
     23 # .IP \fBCCARGS=\fIcompiler_arguments\fR
     24 #	Specifies non-default compiler arguments, for example, a non-default
     25 #	\fIinclude\fR directory.
     26 #	The following directives are special:
     27 # .RS
     28 # .IP \fB-DNO_DEVPOLL\fR
     29 #	Do not build with Solaris /dev/poll support.
     30 #	By default, /dev/poll support is compiled in on platforms that
     31 #	are known to support it.
     32 # .IP \fB-DNO_EPOLL\fR
     33 #	Do not build with Linux EPOLL support.
     34 #	By default, EPOLL support is compiled in on platforms that
     35 #	are known to support it.
     36 # .IP \fB-DNO_IPV6\fR
     37 #	Do not build with IPv6 support.
     38 #	By default, IPv6 support is compiled in on platforms that
     39 #	are known to have IPv6 support.
     40 #
     41 #	Note: this directive is for debugging and testing only. It
     42 #	is not guaranteed to work on all platforms.
     43 # .IP \fB-DNO_KQUEUE\fR
     44 #	Do not build with FreeBSD/NetBSD/OpenBSD/MacOSX KQUEUE support.
     45 #	By default, KQUEUE support is compiled in on platforms that
     46 #	are known to support it.
     47 # .IP \fB-DNO_PCRE\fR
     48 #	Do not build with PCRE support.
     49 #	By default, PCRE support is compiled in when the \fBpcre-config\fR
     50 #	utility is installed.
     51 # .IP \fB-DNO_SIGSETJMP\fR
     52 #	Use setjmp()/longjmp() instead of sigsetjmp()/siglongjmp().
     53 #	By default, Postfix uses sigsetjmp()/siglongjmp() when they
     54 #	appear to work.
     55 # .RE
     56 # .IP \fBDEBUG=\fIdebug_level\fR
     57 #	Specifies a non-default debugging level. The default is \fB-g\fR.
     58 #	Specify \fBDEBUG=\fR to turn off debugging.
     59 # .IP \fBOPT=\fIoptimization_level\fR
     60 #	Specifies a non-default optimization level. The default is \fB-O\fR.
     61 #	Specify \fBOPT=\fR to turn off optimization.
     62 # .IP \fBWARN=\fIwarning_flags\fR
     63 #	Specifies non-default gcc compiler warning options for use when
     64 #	"make" is invoked in a source subdirectory only.
     65 # LICENSE
     66 # .ad
     67 # .fi
     68 #	The Secure Mailer license must be distributed with this software.
     69 # AUTHOR(S)
     70 #	Wietse Venema
     71 #	IBM T.J. Watson Research
     72 #	P.O. Box 704
     73 #	Yorktown Heights, NY 10598, USA
     74 #--
     75 
     76 # Emit system-dependent Makefile macro definitions to standard output.
     77 
     78 # Defaults for most sane systems
     79 
     80 RANLIB=ranlib
     81 SYSLIBS=
     82 AR=ar
     83 ARFL=rv
     84 
     85 # Ugly function to make our error message more visible among the
     86 # garbage that is output by some versions of make(1).
     87 
     88 # By now all shells must have functions.
     89 
     90 error() {
     91    # Alas, tput(1) is not portable so we can't use visual effects.
     92    echo "ATTENTION:" 1>&2;
     93    echo "ATTENTION:" $* 1>&2;
     94    echo "ATTENTION:" 1>&2;
     95    exit 1
     96 }
     97 
     98 case $# in
     99  # Officially supported usage.
    100  0) SYSTEM=`(uname -s) 2>/dev/null`
    101     RELEASE=`(uname -r) 2>/dev/null`
    102     VERSION=`(uname -v) 2>/dev/null`
    103     case "$VERSION" in
    104      dcosx*) SYSTEM=$VERSION;;
    105     esac;;
    106  # Unsupported debug-only mode. Not suitable for cross-platform tests.
    107  2) SYSTEM="$1"; RELEASE="$2";;
    108  *) echo usage: $0 [system release] 1>&2; exit 1;;
    109 esac
    110 
    111 case "$SYSTEM.$RELEASE" in
    112    SCO_SV.3.2)	SYSTYPE=SCO5
    113 		# Use the native compiler by default
    114 		: ${CC="/usr/bin/cc -b elf"}
    115 		CCARGS="$CCARGS -DPIPES_CANT_FIONREAD $CCARGS"
    116 		SYSLIBS="-lsocket -ldbm"
    117 		RANLIB=echo
    118 		;;
    119   UnixWare.5*)	SYSTYPE=UW7
    120 		# Use the native compiler by default
    121 		: ${CC=/usr/bin/cc}
    122 		RANLIB=echo
    123 		SYSLIBS="-lresolv -lsocket -lnsl"
    124 		;;
    125   UNIX_SV.4.2*)	case "`uname -v`" in
    126 	      2.1*) SYSTYPE=UW21
    127 		    # Use the native compiler by default
    128 		    : ${CC=/usr/bin/cc}
    129 		    RANLIB=echo
    130 		    SYSLIBS="-lresolv -lsocket -lnsl -lc -L/usr/ucblib -lucb"
    131 		    ;;
    132 	      *) error "Seems to be UnixWare`uname -v`. Untested.";;
    133 		esac
    134 		;;
    135   FreeBSD.2*)	SYSTYPE=FREEBSD2
    136 		;;
    137   FreeBSD.3*)	SYSTYPE=FREEBSD3
    138 		;;
    139   FreeBSD.4*)	SYSTYPE=FREEBSD4
    140 		;;
    141   FreeBSD.5*)	SYSTYPE=FREEBSD5
    142 		;;
    143   FreeBSD.6*)	SYSTYPE=FREEBSD6
    144 		;;
    145   FreeBSD.7*)	SYSTYPE=FREEBSD7
    146 		;;
    147   FreeBSD.8*)	SYSTYPE=FREEBSD8
    148 		;;
    149   OpenBSD.2*)	SYSTYPE=OPENBSD2
    150 		;;
    151   OpenBSD.3*)	SYSTYPE=OPENBSD3
    152 		;;
    153   OpenBSD.4*)	SYSTYPE=OPENBSD4
    154 		;;
    155   ekkoBSD.1*)	SYSTYPE=EKKOBSD1
    156 		;;
    157    NetBSD.1*)	SYSTYPE=NETBSD1
    158 		;;
    159    NetBSD.2*)	SYSTYPE=NETBSD2
    160 		;;
    161    NetBSD.3*)	SYSTYPE=NETBSD3
    162 		;;
    163    NetBSD.4*)	SYSTYPE=NETBSD4
    164 		;;
    165    NetBSD.5*)	SYSTYPE=NETBSD5
    166 		;;
    167    BSD/OS.2*)	SYSTYPE=BSDI2
    168 		;;
    169    BSD/OS.3*)	SYSTYPE=BSDI3
    170 		;;
    171    BSD/OS.4*)	SYSTYPE=BSDI4
    172 		;;
    173  OSF1.V[3-5].*)	SYSTYPE=OSF1
    174 		# Use the native compiler by default
    175 		: ${CC=cc}
    176 		: ${DEBUG="-g3"}
    177 		case $RELEASE in
    178 		V[0-4].*) CCARGS="$CCARGS -DNO_IPV6";;
    179 		esac
    180 		;;
    181     SunOS.4*)	SYSTYPE=SUNOS4
    182 		SYSLIBS=-lresolv
    183 		;;
    184     SunOS.5*)	SYSTYPE=SUNOS5
    185 		RANLIB=echo
    186 		SYSLIBS="-lresolv -lsocket -lnsl"
    187 		# Stock awk breaks with >10 files.
    188 		test -x /usr/xpg4/bin/awk && AWK=/usr/xpg4/bin/awk
    189 		# Solaris 2.5 added usleep() and POSIX regular expressions
    190 		case $RELEASE in
    191 		    5.[0-4]) CCARGS="$CCARGS -DMISSING_USLEEP -DNO_POSIX_REGEXP";;
    192 		esac
    193 		# Solaris 8 added IPv6 and /dev/poll
    194 		case $RELEASE in
    195 		    5.[0-7]|5.[0-7].*) CCARGS="$CCARGS -DNO_IPV6 -DNO_DEVPOLL";;
    196 		esac
    197 		# Solaris 9 added closefrom(), futimesat() and /dev/*random
    198 		case $RELEASE in
    199 		    5.[0-8]|5.[0-8].*) CCARGS="$CCARGS -DNO_CLOSEFROM -DNO_DEV_URANDOM -DNO_FUTIMESAT";;
    200 		esac
    201 		# Work around broken str*casecmp(). Do it all here instead
    202 		# of having half the solution in the sys_defs.h file.
    203 		CCARGS="$CCARGS -Dstrcasecmp=fix_strcasecmp \
    204 		    -Dstrncasecmp=fix_strncasecmp"
    205 		STRCASE="strcasecmp.o"
    206 		# Avoid common types of braindamage
    207 		case "$LD_LIBRARY_PATH" in
    208 		?*) error "Don't set LD_LIBRARY_PATH";;
    209 		esac
    210 		case "${CC}" in
    211 		*" "*) ;;
    212 		*ucb*) error "Don't use /usr/ucb/cc or ucblib";;
    213 		  cc*) case `which ${CC}` in
    214 		*ucb*) error "Don't use /usr/ucb/cc or ucblib";;
    215 		  esac;;
    216 		esac
    217 		;;
    218    ULTRIX.4*)	SYSTYPE=ULTRIX4
    219 		if [ -f /usr/local/lib/libdb.a ]; then
    220 		    SYSLIBS="$SYSLIBS -ldb"
    221 		    CCARGS="$CCARGS -DHAS_DB"
    222 		    if [ -d /usr/local/include/db ]; then
    223 			CCARGS="$CCARGS -I/usr/local/include/db"
    224 		    fi
    225 		fi
    226 		for l in syslog resolv; do
    227 		    if [ -f /usr/local/lib/lib$l.a ]; then
    228 			SYSLIBS="$SYSLIBS -l$l"
    229 		    fi
    230 		done
    231 		;;
    232        AIX.*)	case "`uname -v`" in
    233 		5)	SYSTYPE=AIX5
    234 			case "$CC" in
    235 			cc|*/cc|xlc|*/xlc) CCARGS="$CCARGS -w -blibpath:/usr/lib:/lib:/usr/local/lib";;
    236 			esac
    237 			CCARGS="$CCARGS -D_ALL_SOURCE -DHAS_POSIX_REGEXP"
    238 			;;
    239 		4)	SYSTYPE=AIX4
    240 			# How embarrassing...
    241 			case "$CC" in
    242 			cc|*/cc|xlc|*/xlc) OPT=; CCARGS="$CCARGS -w -blibpath:/usr/lib:/lib:/usr/local/lib";;
    243 			esac
    244 			CCARGS="$CCARGS -D_ALL_SOURCE -DHAS_POSIX_REGEXP"
    245 			;;
    246 		3)	SYSTYPE=AIX3
    247 			# How embarrassing...
    248 			case "$CC" in
    249 			cc|*/cc|xlc|*/xlc) OPT=; CCARGS="$CCARGS -w";;
    250 			esac
    251 			CCARGS="$CCARGS -D_ALL_SOURCE"
    252 			;;
    253 		*)	error "Unknown AIX version: `uname -v`.";;
    254 		esac;;
    255 		# Tested with RedHat 3.03 on 20020729.
    256     Linux.1*)	SYSTYPE=LINUX1
    257 		SYSLIBS="-ldb"
    258 		;;
    259     Linux.2*)	SYSTYPE=LINUX2
    260 		# Postfix no longer needs DB 1.85 compatibility
    261 		if [ -f /usr/include/db.h ]
    262 		then
    263 		    : we are all set
    264 		elif [ -f /usr/include/db/db.h ]
    265 		then
    266 		    CCARGS="$CCARGS -I/usr/include/db"
    267 		else
    268 		    # No, we're not going to try db1 db2 db3 etc.
    269 		    # On a properly installed system, Postfix builds
    270 		    # by including <db.h> and by linking with -ldb
    271 		    echo "No <db.h> include file found." 1>&2
    272 		    echo "Install the appropriate db*-devel package first." 1>&2
    273 		    echo "See the RELEASE_NOTES file for more information." 1>&2
    274 		    exit 1
    275 		fi
    276 		# GDBM locks the DBM .pag file after open. This breaks postmap.
    277 		# if [ -f /usr/include/gdbm-ndbm.h ]
    278 		# then
    279 		#     CCARGS="$CCARGS -DHAS_DBM -DPATH_NDBM_H='<gdbm-ndbm.h>'"
    280 		#     GDBM_LIBS=gdbm
    281 		# elif [ -f /usr/include/gdbm/ndbm.h ]
    282 		# then
    283 		#     CCARGS="$CCARGS -DHAS_DBM -DPATH_NDBM_H='<gdbm/ndbm.h>'"
    284 		#     GDBM_LIBS=gdbm
    285 		# fi
    286 		SYSLIBS="-ldb"
    287 		for name in nsl resolv $GDBM_LIBS
    288 		do
    289 		    for lib in /usr/lib64 /lib64 /usr/lib /lib
    290 		    do
    291 			test -e $lib/lib$name.a -o -e $lib/lib$name.so && {
    292 			    SYSLIBS="$SYSLIBS -l$name"
    293 			    break
    294 			}
    295 		    done
    296 		done
    297 		# Kernel 2.4 added IPv6
    298 		case "$RELEASE" in
    299 		2.[0-3].*) CCARGS="$CCARGS -DNO_IPV6";;
    300 		esac
    301 		# Kernel 2.6 added EPOLL
    302 		case "$RELEASE" in
    303 		2.[0-5].*) CCARGS="$CCARGS -DNO_EPOLL";;
    304 		    # Workaround for retarded libc 
    305 		    2.6.*)
    306 		       if [ `expr "X$CCARGS" : "X.*-DNO_EPOLL"` -gt 0 ]
    307                        then
    308                            :
    309                        elif [ ! -e /usr/include/sys/epoll.h ]
    310                        then
    311                            echo CCARGS="$CCARGS -DNO_EPOLL"
    312                        else
    313 			   trap 'rm -f makedefs.test makedefs.test.[co]' 1 2 3 15
    314 			   cat >makedefs.test.c <<'EOF'
    315 #include <sys/types.h>
    316 #include <sys/epoll.h>
    317 #include <errno.h>
    318 #include <stdio.h>
    319 #include <stdlib.h>
    320 
    321 int     main(int argc, char **argv)
    322 {
    323     int     epoll_handle;
    324 
    325     if ((epoll_handle = epoll_create(1)) < 0) {
    326 	perror("epoll_create");
    327 	exit(1);
    328     }
    329     exit(0);
    330 }
    331 EOF
    332 			   ${CC-gcc} -o makedefs.test makedefs.test.c || exit 1
    333 			   ./makedefs.test 2>/dev/null ||
    334 				CCARGS="$CCARGS -DNO_EPOLL"
    335 			   rm -f makedefs.test makedefs.test.[co]
    336 		       fi;;
    337 		esac
    338 		;;
    339      GNU.0*|GNU/kFreeBSD.[567]*)
    340      		SYSTYPE=GNU0
    341 		# Postfix no longer needs DB 1.85 compatibility
    342 		if [ -f /usr/include/db.h ]
    343 		then
    344 		    : we are all set
    345 		elif [ -f /usr/include/db/db.h ]
    346 		then
    347 		    CCARGS="$CCARGS -I/usr/include/db"
    348 		else
    349 		    # No, we're not going to try db1 db2 db3 etc.
    350 		    # On a properly installed system, Postfix builds
    351 		    # by including <db.h> and by linking with -ldb
    352 		    echo "No <db.h> include file found." 1>&2
    353 		    echo "Install the appropriate db*-devel package first." 1>&2
    354 		    echo "See the RELEASE_NOTES file for more information." 1>&2
    355 		    exit 1
    356 		fi
    357 		SYSLIBS="-ldb"
    358 		for name in nsl resolv
    359 		do
    360 		    for lib in /usr/lib64 /lib64 /usr/lib /lib
    361 		    do
    362 			test -e $lib/lib$name.a -o -e $lib/lib$name.so && {
    363 			    SYSLIBS="$SYSLIBS -l$name"
    364 			    break
    365 			}
    366 		    done
    367 		done
    368 		case "`uname -s`" in
    369 		GNU)
    370 			# currently no IPv6 support on Hurd
    371 			CCARGS="$CCARGS -DNO_IPV6"
    372 			;;
    373 		esac
    374 		;;
    375      IRIX*.5.*)	SYSTYPE=IRIX5
    376 		# Use the native compiler by default
    377 		: ${CC=cc} ${DEBUG="-g3"}
    378 		RANLIB=echo
    379 		;;
    380      IRIX*.6.*)	SYSTYPE=IRIX6
    381 		# Use the native compiler by default, and allow nested comments.
    382 		: ${CC="cc -woff 1009,1116,1412"}
    383 		RANLIB=echo
    384 		;;
    385 HP-UX.A.09.*)	SYSTYPE=HPUX9
    386 		SYSLIBS=-ldbm
    387 		CCARGS="$CCARGS -DMISSING_USLEEP"
    388 		if [ -f /usr/lib/libdb.a ]; then
    389 		    CCARGS="$CCARGS -DHAS_DB"
    390 		    SYSLIBS="$SYSLIBS -ldb"
    391 		fi
    392 		;;
    393 HP-UX.B.10.*)	SYSTYPE=HPUX10
    394 		CCARGS="$CCARGS `nm /usr/lib/libc.a 2>/dev/null |
    395 		    (grep usleep >/dev/null || echo '-DMISSING_USLEEP')`"
    396 		if [ -f /usr/lib/libdb.a ]; then
    397 		    CCARGS="$CCARGS -DHAS_DB"
    398 		    SYSLIBS=-ldb
    399 		fi
    400 		;;
    401 HP-UX.B.11.*)	SYSTYPE=HPUX11
    402 		SYSLIBS=-lnsl
    403 		if [ -f /usr/lib/libdb.a ]; then
    404 		    CCARGS="$CCARGS -DHAS_DB"
    405 		    SYSLIBS="$SYSLIBS -ldb"
    406 		fi
    407 		;;
    408 ReliantUNIX-?.5.43) SYSTYPE=ReliantUnix543
    409 		RANLIB=echo
    410 		SYSLIBS="-lresolv -lsocket -lnsl"
    411 		;;
    412     Darwin.*)   SYSTYPE=MACOSX
    413 		# Use the native compiler by default
    414 		: ${CC=cc}
    415 		# Darwin > 1.3 uses awk and flat_namespace
    416 		case $RELEASE in
    417 		 1.[0-3]) AWK=gawk;;
    418 		       *) AWK=awk
    419 			  SYSLIBS=-flat_namespace;;
    420 		esac
    421 		# Darwin 7 adds IPv6 support, BIND_8_COMPAT, NO_NETINFO
    422 		case $RELEASE in
    423 		 [1-6].*) CCARGS="$CCARGS -DNO_IPV6";;
    424 		       *) CCARGS="$CCARGS -DBIND_8_COMPAT -DNO_NETINFO";;
    425 		esac
    426 		# Darwin 10.3.0 no longer has <nameser8_compat.h>.
    427 		case $RELEASE in
    428 		     ?.*) CCARGS="$CCARGS -DRESOLVE_H_NEEDS_NAMESER8_COMPAT_H";;
    429 		       *) CCARGS="$CCARGS -DRESOLVE_H_NEEDS_ARPA_NAMESER_COMPAT_H";;
    430 		esac
    431 		# kqueue and/or poll are broken up to and including MacOS X 10.5
    432 		CCARGS="$CCARGS -DNO_KQUEUE"
    433 #		# Darwin 8.11.1 has kqueue support, but let's play safe
    434 #		case $RELEASE in
    435 #		 [1-8].*) CCARGS="$CCARGS -DNO_KQUEUE";;
    436 #		       *) trap 'rm -f makedefs.test makedefs.test.[co]' 1 2 3 15
    437 #			  cat >makedefs.test.c <<'EOF'
    438 #/* Adapted from libevent. */
    439 #
    440 ##include <sys/types.h>
    441 ##include <sys/event.h>
    442 ##include <sys/time.h>
    443 ##include <string.h>
    444 ##include <stdlib.h>
    445 ##include <stdio.h>
    446 #
    447 ##ifndef EV_SET
    448 ##define EV_SET(kp, id, fi, fl, ffl, da, ud) do { \
    449 #	struct kevent *__kp = (kp); \
    450 #	__kp->ident = (id); \
    451 #	__kp->filter = (fi); \
    452 #	__kp->flags = (fl); \
    453 #	__kp->fflags = (ffl); \
    454 #	__kp->data = (da); \
    455 #	__kp->udata = (ud); \
    456 #    } while(0)
    457 ##endif
    458 #
    459 #int     main(int argc, char **argv)
    460 #{
    461 #    int     kq;
    462 #    struct kevent test_change;
    463 #    struct kevent test_result;
    464 #
    465 #    if ((kq = kqueue()) < 0) {
    466 #	perror("kqueue");
    467 #	exit(1);
    468 #    }
    469 ##define TEST_FD (-1)
    470 #
    471 #    EV_SET(&test_change, TEST_FD, EVFILT_READ, EV_ADD, 0, 0, 0);
    472 #    if (kevent(kq,
    473 #	       &test_change, sizeof(test_change) / sizeof(struct kevent),
    474 #	       &test_result, sizeof(test_result) / sizeof(struct kevent),
    475 #	       (struct timespec *) 0) != 1 ||
    476 #	test_result.ident != TEST_FD ||
    477 #	test_result.flags != EV_ERROR) {
    478 #	fprintf(stderr, "Error: kevent reports errors incorrectly\n");
    479 #	exit(1);
    480 #    }
    481 #    exit(0);
    482 #}
    483 #EOF
    484 #			  $CC -o makedefs.test makedefs.test.c || exit 1
    485 #			  ./makedefs.test 2>/dev/null || 
    486 #				CCARGS="$CCARGS -DNO_KQUEUE"
    487 #			  rm -f makedefs.test makedefs.test.[co];;
    488 #		esac
    489 		;;
    490     dcosx.1*)	SYSTYPE=DCOSX1
    491 		RANLIB=echo
    492 		SYSLIBS="-lresolv -lsocket -lnsl -lc -lrpcsvc -L/usr/ucblib -lucb"
    493 		;;
    494 
    495 	 ".")	if [ -d /NextApps ]; then
    496 		    SYSTYPE=`hostinfo | sed -n \
    497 			's/^.*NeXT Mach 3.*$/NEXTSTEP3/;/NEXTSTEP3/{p;q;}'`
    498 		    if [ "$SYSTYPE" = "" ]; then
    499 			SYSTYPE=`hostinfo | sed -n \
    500 			    's/^.*NeXT Mach 4.*$/OPENSTEP4/;/OPENSTEP4/{p;q;}'`
    501 		    fi
    502 		    : ${CC=cc}
    503 		    RANLIB="sleep 5; ranlib"
    504 		else
    505 		    error "Unable to determine your system type."
    506 		fi
    507 		;;
    508 	   *)	error "Unknown system type: $SYSTEM $RELEASE";;
    509 esac
    510 
    511 #
    512 # sigsetjmp()/siglongjmp() can be "better" than setjmp()/longjmp()
    513 # if used wisely (that is: almost never, just like signals).
    514 # Unfortunately some implementations have been buggy in the past.
    515 #
    516 case "$CCARGS" in
    517  *-DNO_SIGSETJMP*) ;;
    518                 *) trap 'rm -f makedefs.test makedefs.test.[co]' 1 2 3 15
    519 		   cat >makedefs.test.c <<'EOF'
    520 #include <setjmp.h>
    521 #include <stdlib.h>
    522 #include <stdio.h>
    523 
    524 static int count = 0;
    525 
    526 int     main(int argc, char **argv)
    527 {
    528     sigjmp_buf env;
    529     int     retval;
    530 
    531     switch (retval = sigsetjmp(env, 1)) {
    532     case 0:
    533 	siglongjmp(env, 12345);
    534     case 12345:
    535 	break;
    536     default:
    537 	fprintf(stderr, "Error: siglongjmp ignores second argument\n");
    538 	exit(1);
    539     }
    540 
    541     switch (retval = sigsetjmp(env, 1)) {
    542     case 0:
    543 	if (count++ > 0) {
    544 	    fprintf(stderr, "Error: not overriding siglongjmp(env, 0)\n");
    545 	    exit(1);
    546 	}
    547 	siglongjmp(env, 0);
    548     case 1:
    549 	break;
    550     default:
    551 	fprintf(stderr, "Error: overriding siglongjmp(env, 0) with %d\n",
    552 		retval);
    553 	exit(1);
    554     }
    555     exit(0);
    556 }
    557 EOF
    558 		   ${CC-gcc} -o makedefs.test makedefs.test.c || exit 1
    559 		   ./makedefs.test 2>/dev/null ||
    560 			CCARGS="$CCARGS -DNO_SIGSETJMP"
    561 		   rm -f makedefs.test makedefs.test.[co]
    562 esac
    563 
    564 #
    565 # OpenSSL has no configuration query utility, but we don't try to
    566 # guess. We assume includes in /usr/include/openssl and libraries in
    567 # /usr/lib, or in their /usr/local equivalents. If the OpenSSL files
    568 # are in a non-standard place, their locations need to be specified.
    569 #
    570 #case "$CCARGS" in
    571 # *-DUSE_TLS*)	;;
    572 #  *-DNO_TLS*)	;;
    573 #           *)	CCARGS="$CCARGS -DUSE_TLS"
    574 #		AUXLIBS="$AUXLIBS -lssl -lcrypto"
    575 #		;;
    576 #esac
    577 
    578 #
    579 # PCRE 3.x has a pcre-config utility so we don't have to guess.
    580 #
    581 case "$CCARGS" in
    582 *-DHAS_PCRE*)	;;
    583  *-DNO_PCRE*)	;;
    584            *)	pcre_cflags=`(pcre-config --cflags) 2>/dev/null` &&
    585 		    pcre_libs=`(pcre-config --libs) 2>/dev/null` && {
    586 			CCARGS="$CCARGS -DHAS_PCRE $pcre_cflags"
    587 			AUXLIBS="$AUXLIBS $pcre_libs"
    588 		}
    589 		;;
    590 esac
    591 
    592 # Defaults that can be overruled (make makefiles CC=cc OPT=-O6 DEBUG=)
    593 # Disable optimizations by default when compiling for Purify. Disable
    594 # optimizations by default with gcc 2.8, until the compiler is known to
    595 # be OK. Those who dare can still overrule this (make makefiles OPT=-O).
    596 
    597 case "$CC" in
    598  *purify*) : ${OPT=};;
    599 */gcc|gcc) case `$CC -v` in
    600 	   "gcc version 2.8"*) : ${OPT=};;
    601 	   esac;;
    602       *CC) error "Don't use CC. That's the C++ compiler";;
    603         *) : ${OPT='-O'};;
    604 esac
    605 #
    606 # "gcc -W" 3.4.2 no longer reports functions that fail to return a
    607 # result.  Use "gcc -Wall -Wno-comment" instead. We'll figure out
    608 # later if the other -Wmumble options are really redundant. Having
    609 # een burned once by a compiler that lies about what warnings it
    610 # produces, not taking that chance again.
    611 
    612 : ${CC='gcc $(WARN)'} ${OPT='-O'} ${DEBUG='-g'} ${AWK=awk} \
    613 ${WARN='-Wall -Wno-comment -Wformat -Wimplicit -Wmissing-prototypes \
    614 	-Wparentheses -Wstrict-prototypes -Wswitch -Wuninitialized \
    615 	-Wunused -Wno-missing-braces'}
    616 
    617 export SYSTYPE AR ARFL RANLIB SYSLIBS CC OPT DEBUG AWK OPTS
    618 
    619 # Snapshot only.
    620 #CCARGS="$CCARGS -DSNAPSHOT"
    621 
    622 # Non-production: needs thorough testing, or major changes are still
    623 # needed before the code stabilizes.
    624 #CCARGS="$CCARGS -DNONPROD"
    625 
    626 sed 's/  / /g' <<EOF
    627 SYSTYPE	= $SYSTYPE
    628 AR	= $AR
    629 ARFL	= $ARFL
    630 RANLIB	= $RANLIB
    631 SYSLIBS	= $AUXLIBS $SYSLIBS
    632 CC	= $CC $CCARGS
    633 OPT	= $OPT
    634 DEBUG	= $DEBUG
    635 AWK	= $AWK
    636 STRCASE = $STRCASE
    637 EXPORT	= AUXLIBS='$AUXLIBS' CCARGS='$CCARGS' OPT='$OPT' DEBUG='$DEBUG'
    638 WARN	= $WARN
    639 EOF
    640